(function() {
    "use strict";

    angular.module("weChatApp")
        .directive("customTable", Table)
    ;

    function Table() {
        return {
            restrict: "E",
            templateUrl: "views/custom-table.html",
            scope: {
                headers: '<',
                rows: '<'
            },
            controller: ["$scope", function($scope) {
                var defaultSortingHeader = _.find($scope.headers, function(header) {
                    return header.defaultSort;
                });
                if(defaultSortingHeader) {
                    $scope.orderKey = "-" + defaultSortingHeader.name;
                } else if($scope.headers[0]) {
                    $scope.orderKey = "-" + $scope.headers[0].name;
                }

                $scope.sortColumn = function(header) {
                    if($scope.orderKey === header.name) {
                        $scope.orderKey = "-" + header.name;
                    } else {
                        $scope.orderKey = header.name;
                    }
                };
            }]
        };
    }
}());